# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UserSignatureDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'signature_font': 'str',
        'signature_id': 'str',
        'signature_initials': 'str',
        'signature_name': 'str'
    }

    attribute_map = {
        'signature_font': 'signatureFont',
        'signature_id': 'signatureId',
        'signature_initials': 'signatureInitials',
        'signature_name': 'signatureName'
    }

    def __init__(self, signature_font=None, signature_id=None, signature_initials=None, signature_name=None):  # noqa: E501
        """UserSignatureDefinition - a model defined in Swagger"""  # noqa: E501

        self._signature_font = None
        self._signature_id = None
        self._signature_initials = None
        self._signature_name = None
        self.discriminator = None

        if signature_font is not None:
            self.signature_font = signature_font
        if signature_id is not None:
            self.signature_id = signature_id
        if signature_initials is not None:
            self.signature_initials = signature_initials
        if signature_name is not None:
            self.signature_name = signature_name

    @property
    def signature_font(self):
        """Gets the signature_font of this UserSignatureDefinition.  # noqa: E501

          # noqa: E501

        :return: The signature_font of this UserSignatureDefinition.  # noqa: E501
        :rtype: str
        """
        return self._signature_font

    @signature_font.setter
    def signature_font(self, signature_font):
        """Sets the signature_font of this UserSignatureDefinition.

          # noqa: E501

        :param signature_font: The signature_font of this UserSignatureDefinition.  # noqa: E501
        :type: str
        """

        self._signature_font = signature_font

    @property
    def signature_id(self):
        """Gets the signature_id of this UserSignatureDefinition.  # noqa: E501

        Specifies the signature ID associated with the signature name. You can use the signature ID in the URI in place of the signature name, and the value stored in the `signatureName` property in the body is used. This allows the use of special characters (such as \"&\", \"<\", \">\") in a the signature name. Note that with each update to signatures, the returned signature ID might change, so the caller will need to trigger off the signature name to get the new signature ID.  # noqa: E501

        :return: The signature_id of this UserSignatureDefinition.  # noqa: E501
        :rtype: str
        """
        return self._signature_id

    @signature_id.setter
    def signature_id(self, signature_id):
        """Sets the signature_id of this UserSignatureDefinition.

        Specifies the signature ID associated with the signature name. You can use the signature ID in the URI in place of the signature name, and the value stored in the `signatureName` property in the body is used. This allows the use of special characters (such as \"&\", \"<\", \">\") in a the signature name. Note that with each update to signatures, the returned signature ID might change, so the caller will need to trigger off the signature name to get the new signature ID.  # noqa: E501

        :param signature_id: The signature_id of this UserSignatureDefinition.  # noqa: E501
        :type: str
        """

        self._signature_id = signature_id

    @property
    def signature_initials(self):
        """Gets the signature_initials of this UserSignatureDefinition.  # noqa: E501

          # noqa: E501

        :return: The signature_initials of this UserSignatureDefinition.  # noqa: E501
        :rtype: str
        """
        return self._signature_initials

    @signature_initials.setter
    def signature_initials(self, signature_initials):
        """Sets the signature_initials of this UserSignatureDefinition.

          # noqa: E501

        :param signature_initials: The signature_initials of this UserSignatureDefinition.  # noqa: E501
        :type: str
        """

        self._signature_initials = signature_initials

    @property
    def signature_name(self):
        """Gets the signature_name of this UserSignatureDefinition.  # noqa: E501

        Specifies the user signature name.  # noqa: E501

        :return: The signature_name of this UserSignatureDefinition.  # noqa: E501
        :rtype: str
        """
        return self._signature_name

    @signature_name.setter
    def signature_name(self, signature_name):
        """Sets the signature_name of this UserSignatureDefinition.

        Specifies the user signature name.  # noqa: E501

        :param signature_name: The signature_name of this UserSignatureDefinition.  # noqa: E501
        :type: str
        """

        self._signature_name = signature_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserSignatureDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSignatureDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
